#ifdef ENABLE_AXISTRACE
/* TRACE ADDED BY THE TRACE INSTRUMENTOR TOOL */
#include "../common/AxisTrace.h"
#endif
/*
 *   Copyright 2003-2004 The Apache Software Foundation.
// (c) Copyright IBM Corp. 2004, 2005 All Rights Reserved
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

#include <axis/IHeaderBlock.hpp>

AXIS_CPP_NAMESPACE_USE

extern "C" {

#include <axis/GDefine.h>

#include <axis/AxisUserAPI.h>

#include <axis/BasicNode.h>

#include <axis/SoapEnvVersions.h>

#include <axis/IHeaderBlock.h>

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscCreateNamespaceDeclINamespace(AXISCHANDLE headerBlock, const AxiscChar * prefix, 
	const AxiscChar * uri) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscCreateNamespaceDeclINamespace", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&headerBlock),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&prefix),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&uri));	  /* AUTOINSERTED TRACE */
	#endif

	IHeaderBlock *hdr = (IHeaderBlock*)headerBlock;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = ((AXISCHANDLE)(hdr->createNamespaceDecl(prefix,uri)));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscCreateNamespaceDeclINamespace", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (AXISCHANDLE)(hdr->createNamespaceDecl(prefix,uri));
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscGetFirstChildBasicNodeIHeaderBlock(AXISCHANDLE headerBlock) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetFirstChildBasicNodeIHeaderBlock", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&headerBlock));	  /* AUTOINSERTED TRACE */
	#endif

	IHeaderBlock *hdr = (IHeaderBlock*)headerBlock;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = ((AXISCHANDLE)(hdr->getFirstChild()));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetFirstChildBasicNodeIHeaderBlock", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (AXISCHANDLE)(hdr->getFirstChild());
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO int axiscGetNoOfChildrenIHeaderBlock(AXISCHANDLE headerBlock) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetNoOfChildrenIHeaderBlock", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&headerBlock));	  /* AUTOINSERTED TRACE */
	#endif

	IHeaderBlock *hdr = (IHeaderBlock*)headerBlock;
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (hdr->getNoOfChildren());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetNoOfChildrenIHeaderBlock", NULL, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return hdr->getNoOfChildren();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscCreateChildBasicNode(AXISCHANDLE headerBlock, AXISC_NODE_TYPE eNODE_TYPE, 
	AxiscChar * pachLocalName, AxiscChar * pachPrefix, 
	AxiscChar * pachUri, AxiscChar * pachValue) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscCreateChildBasicNode", NULL, 6,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&headerBlock),
					TRACETYPE_DATA, sizeof(AXISC_NODE_TYPE), ((void*)&eNODE_TYPE),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pachLocalName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pachPrefix),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pachUri),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pachValue));	  /* AUTOINSERTED TRACE */
	#endif

	IHeaderBlock *hdr = (IHeaderBlock*)headerBlock;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = ((AXISCHANDLE)(hdr->createChild((NODE_TYPE)eNODE_TYPE,pachLocalName,pachPrefix,pachUri,pachValue)));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscCreateChildBasicNode", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (AXISCHANDLE)(hdr->createChild((NODE_TYPE)eNODE_TYPE,pachLocalName,pachPrefix,pachUri,pachValue));
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscCreateImmediateChildBasicNode(AXISCHANDLE headerBlock, AXISC_NODE_TYPE eNODE_TYPE, 
	AxiscChar * pachLocalName, AxiscChar * pachPrefix, 
	AxiscChar * pachUri, AxiscChar * pachValue) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscCreateImmediateChildBasicNode", NULL, 6,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&headerBlock),
					TRACETYPE_DATA, sizeof(AXISC_NODE_TYPE), ((void*)&eNODE_TYPE),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pachLocalName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pachPrefix),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pachUri),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pachValue));	  /* AUTOINSERTED TRACE */
	#endif

	IHeaderBlock *hdr = (IHeaderBlock*)headerBlock;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = ((AXISCHANDLE)(hdr->createImmediateChild((NODE_TYPE)eNODE_TYPE,pachLocalName,pachPrefix,pachUri,pachValue)));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscCreateImmediateChildBasicNode", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (AXISCHANDLE)(hdr->createImmediateChild((NODE_TYPE)eNODE_TYPE,pachLocalName,pachPrefix,pachUri,pachValue));
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscCreateStdAttribute(AXISCHANDLE headerBlock, AXISC_HEADER_BLOCK_STD_ATTR_TYPE eStdAttrType, 
	AXISC_SOAP_VERSION eSOAP_VERSION) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscCreateStdAttribute", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&headerBlock),
					TRACETYPE_DATA, sizeof(AXISC_HEADER_BLOCK_STD_ATTR_TYPE), ((void*)&eStdAttrType),
					TRACETYPE_DATA, sizeof(AXISC_SOAP_VERSION), ((void*)&eSOAP_VERSION));	  /* AUTOINSERTED TRACE */
	#endif

	IHeaderBlock *hdr = (IHeaderBlock*)headerBlock;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = ((AXISCHANDLE)(hdr->createStdAttribute((HEADER_BLOCK_STD_ATTR_TYPE)eStdAttrType, (SOAP_VERSION)eSOAP_VERSION)));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscCreateStdAttribute", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (AXISCHANDLE)(hdr->createStdAttribute((HEADER_BLOCK_STD_ATTR_TYPE)eStdAttrType, (SOAP_VERSION)eSOAP_VERSION));
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscCreateAttributeIHeaderBlock(AXISCHANDLE headerBlock, const AxiscChar * localname, 
	const AxiscChar * prefix, const AxiscChar * uri, const AxiscChar * value) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscCreateAttributeIHeaderBlock", NULL, 5,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&headerBlock),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&localname),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&prefix),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&uri),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&value));	  /* AUTOINSERTED TRACE */
	#endif

	IHeaderBlock *hdr = (IHeaderBlock*)headerBlock;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = ((AXISCHANDLE)(hdr->createAttribute(localname, prefix, uri, value)));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscCreateAttributeIHeaderBlock", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (AXISCHANDLE)(hdr->createAttribute(localname, prefix, uri, value));
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO const AxiscChar * axiscGetAttributeValue(AXISCHANDLE headerBlock, const AxiscChar * localname, 
	const AxiscChar * prefix) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeValue", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&headerBlock),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&localname),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&prefix));	  /* AUTOINSERTED TRACE */
	#endif

	IHeaderBlock *hdr = (IHeaderBlock*)headerBlock;
		{
		#ifdef ENABLE_AXISTRACE
			const AxiscChar* traceRet = (hdr->getAttributeValue(localname, prefix));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeValue", NULL, 0,
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return hdr->getAttributeValue(localname, prefix);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscGetLastChildBasicNodeIHeaderBlock(AXISCHANDLE headerBlock) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetLastChildBasicNodeIHeaderBlock", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&headerBlock));	  /* AUTOINSERTED TRACE */
	#endif

	IHeaderBlock *hdr = (IHeaderBlock*)headerBlock;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = ((AXISCHANDLE)(hdr->getLastChild()));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetLastChildBasicNodeIHeaderBlock", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (AXISCHANDLE)(hdr->getLastChild());
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscGetChildBasicNodeIHeaderBlock(AXISCHANDLE headerBlock, int iChildPosition) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetChildBasicNodeIHeaderBlock", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&headerBlock),
					TRACETYPE_INT, 0, ((void*)&iChildPosition));	  /* AUTOINSERTED TRACE */
	#endif

	IHeaderBlock *hdr = (IHeaderBlock*)headerBlock;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = ((AXISCHANDLE)(hdr->getChild(iChildPosition)));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetChildBasicNodeIHeaderBlock", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (AXISCHANDLE)(hdr->getChild(iChildPosition));
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO int axiscAddChildIHeaderBlock(AXISCHANDLE headerBlock, AXISCHANDLE pBasicNode) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscAddChildIHeaderBlock", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&headerBlock),
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&pBasicNode));	  /* AUTOINSERTED TRACE */
	#endif

	IHeaderBlock *hdr = (IHeaderBlock*)headerBlock;
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (hdr->addChild((BasicNode*)pBasicNode));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscAddChildIHeaderBlock", NULL, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return hdr->addChild((BasicNode*)pBasicNode);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO int axiscSetLocalNameIHeaderBlock(AXISCHANDLE headerBlock, const AxiscChar * localname) 
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetLocalNameIHeaderBlock", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&headerBlock),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&localname));	  /* AUTOINSERTED TRACE */
	#endif

	if(0==localname)
	{
			{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (AXIS_FAIL);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetLocalNameIHeaderBlock", NULL, 1,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return AXIS_FAIL;
		#endif
	}

	}
	IHeaderBlock *hdr = (IHeaderBlock*)headerBlock;
	hdr->setLocalName(localname);
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (AXIS_SUCCESS);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetLocalNameIHeaderBlock", NULL, 2,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return AXIS_SUCCESS;
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO const AxiscChar * axiscGetLocalNameIHeaderBlock(AXISCHANDLE headerBlock) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetLocalNameIHeaderBlock", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&headerBlock));	  /* AUTOINSERTED TRACE */
	#endif

	IHeaderBlock *hdr = (IHeaderBlock*)headerBlock;
		{
		#ifdef ENABLE_AXISTRACE
			const AxiscChar* traceRet = (hdr->getLocalName());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetLocalNameIHeaderBlock", NULL, 0,
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return hdr->getLocalName();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO void axiscSetUriIHeaderBlock(AXISCHANDLE headerBlock, const AxiscChar * uri) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetUriIHeaderBlock", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&headerBlock),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&uri));	  /* AUTOINSERTED TRACE */
	#endif

	IHeaderBlock *hdr = (IHeaderBlock*)headerBlock;
	hdr->setURI(uri);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetUriIHeaderBlock", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AXISC_STORAGE_CLASS_INFO int axiscSetPrefixIHeaderBlock(AXISCHANDLE headerBlock, const AxiscChar * prefix) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetPrefixIHeaderBlock", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&headerBlock),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&prefix));	  /* AUTOINSERTED TRACE */
	#endif

	if(0==prefix)
	{
			{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (AXIS_FAIL);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetPrefixIHeaderBlock", NULL, 1,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return AXIS_FAIL;
		#endif
	}

	}
	IHeaderBlock *hdr = (IHeaderBlock*)headerBlock;
	hdr->setPrefix(prefix);
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (AXIS_SUCCESS);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetPrefixIHeaderBlock", NULL, 2,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return AXIS_SUCCESS;
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscCloneHeaderBlockIHeaderBlock(AXISCHANDLE headerBlock) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscCloneHeaderBlockIHeaderBlock", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&headerBlock));	  /* AUTOINSERTED TRACE */
	#endif

	IHeaderBlock *hdr = (IHeaderBlock*)headerBlock;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = ((AXISCHANDLE)(hdr->clone()));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscCloneHeaderBlockIHeaderBlock", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (AXISCHANDLE)(hdr->clone());
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO void axiscDestroyIHeaderBlock(AXISCHANDLE headerBlock) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscDestroyIHeaderBlock", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&headerBlock));	  /* AUTOINSERTED TRACE */
	#endif

	IHeaderBlock *hdr = (IHeaderBlock*)headerBlock;
	delete hdr;
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscDestroyIHeaderBlock", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

}

