#ifdef ENABLE_AXISTRACE
/* TRACE ADDED BY THE TRACE INSTRUMENTOR TOOL */
#include "../common/AxisTrace.h"
#endif
/*
 *   Copyright 2003-2004 The Apache Software Foundation.
// (c) Copyright IBM Corp. 2004, 2005 All Rights Reserved
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

#include <axis/IWrapperSoapDeSerializer.hpp>

AXIS_CPP_NAMESPACE_USE

extern "C" {

#include <axis/GDefine.h>

#include <axis/AxisUserAPI.h>

#include <axis/BasicNode.h>

#include <axis/SoapEnvVersions.h>

#include <axis/TypeMapping.h>

#include <axis/IWrapperSoapDeSerializer.h>

AXISC_STORAGE_CLASS_INFO void axiscDestroyIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscDestroyIWrapperSoapDeSerializer", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
	delete dz;
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscDestroyIWrapperSoapDeSerializer", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AXISC_STORAGE_CLASS_INFO int axiscCheckMessageBody(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscCheckMessageBody", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (dz->checkMessageBody(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscCheckMessageBody", NULL, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->checkMessageBody(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO void * axiscCheckForFault(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscCheckForFault", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			void* traceRet = (dz->checkForFault(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscCheckForFault", NULL, 0,
					TRACETYPE_POINTER, 1, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->checkForFault(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO Axisc_Array* axiscGetCmplxArrayIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, Axisc_Array * pArray, void * pDZFunct, 
	void * pCreFunct, void * pDelFunct, void * pSizeFunct, 
	const AxiscChar * pName, const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetCmplxArrayIWrapperSoapDeSerializer", NULL, 8,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(Axisc_Array), ((void*)&pArray),
					TRACETYPE_POINTER, 1, ((void*)&pDZFunct),
					TRACETYPE_POINTER, 1, ((void*)&pCreFunct),
					TRACETYPE_POINTER, 1, ((void*)&pDelFunct),
					TRACETYPE_POINTER, 1, ((void*)&pSizeFunct),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
	// TODO: not implemented
	Axisc_Array* aa = new Axisc_Array();
	memset(aa,0,sizeof(aa));
		{
		#ifdef ENABLE_AXISTRACE
			Axisc_Array* traceRet = (aa);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetCmplxArrayIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(Axisc_Array), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return aa;
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO Axisc_Array* axiscGetBasicArrayIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, AXISC_XSDTYPE nType, 
	const AxiscChar * pName, const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetBasicArrayIWrapperSoapDeSerializer", NULL, 4,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_DATA, sizeof(AXISC_XSDTYPE), ((void*)&nType),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
	// TODO: not implemented
	Axisc_Array* aa = new Axisc_Array();
	memset(aa,0,sizeof(aa));
		{
		#ifdef ENABLE_AXISTRACE
			Axisc_Array* traceRet = (aa);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetBasicArrayIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(Axisc_Array), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return aa;
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO void * axiscGetCmplxObjectIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, void * pDZFunct, 
	void * pCreFunct, void * pDelFunct, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetCmplxObjectIWrapperSoapDeSerializer", NULL, 6,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, 1, ((void*)&pDZFunct),
					TRACETYPE_POINTER, 1, ((void*)&pCreFunct),
					TRACETYPE_POINTER, 1, ((void*)&pDelFunct),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			void* traceRet = (dz->getCmplxObject(pDZFunct,pCreFunct,pDelFunct,pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetCmplxObjectIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, 1, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getCmplxObject(pDZFunct,pCreFunct,pDelFunct,pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__int * axiscGetElementAsIntIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetElementAsIntIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__int* traceRet = (dz->getElementAsInt(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetElementAsIntIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__int), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getElementAsInt(pName,pNamespace);
		#endif
	}

}

/*AXISC_STORAGE_CLASS_INFO int axiscGetFaultDetailIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, char * * ppcDetail) {
	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
	return dz->getFaultDetail(ppcDetail);
}*/

AXISC_STORAGE_CLASS_INFO xsdc__boolean * axiscGetElementAsBooleanIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetElementAsBooleanIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__boolean* traceRet = ((xsdc__boolean *)(dz->getElementAsBoolean(pName,pNamespace)));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetElementAsBooleanIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__boolean), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (xsdc__boolean *)(dz->getElementAsBoolean(pName,pNamespace));
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__unsignedInt * axiscGetElementAsUnsignedIntIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetElementAsUnsignedIntIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__unsignedInt* traceRet = (dz->getElementAsUnsignedInt(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetElementAsUnsignedIntIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__unsignedInt), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getElementAsUnsignedInt(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__short * axiscGetElementAsShortIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetElementAsShortIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__short* traceRet = (dz->getElementAsShort(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetElementAsShortIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__short), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getElementAsShort(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__unsignedShort * axiscGetElementAsUnsignedShortIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetElementAsUnsignedShortIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__unsignedShort* traceRet = (dz->getElementAsUnsignedShort(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetElementAsUnsignedShortIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__unsignedShort), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getElementAsUnsignedShort(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__byte * axiscGetElementAsByteIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetElementAsByteIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__byte* traceRet = (dz->getElementAsByte(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetElementAsByteIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__byte), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getElementAsByte(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__unsignedByte * axiscGetElementAsUnsignedByteIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetElementAsUnsignedByteIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__unsignedByte* traceRet = (dz->getElementAsUnsignedByte(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetElementAsUnsignedByteIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__unsignedByte), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getElementAsUnsignedByte(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__long * axiscGetElementAsLongIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetElementAsLongIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__long* traceRet = (dz->getElementAsLong(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetElementAsLongIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__long), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getElementAsLong(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__integer * axiscGetElementAsIntegerIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetElementAsIntegerIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__integer* traceRet = (dz->getElementAsInteger(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetElementAsIntegerIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__integer), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getElementAsInteger(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__unsignedLong * axiscGetElementAsUnsignedLongIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetElementAsUnsignedLongIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__unsignedLong* traceRet = (dz->getElementAsUnsignedLong(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetElementAsUnsignedLongIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__unsignedLong), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getElementAsUnsignedLong(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__float * axiscGetElementAsFloatIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetElementAsFloatIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__float* traceRet = (dz->getElementAsFloat(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetElementAsFloatIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__float), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getElementAsFloat(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__double * axiscGetElementAsDoubleIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetElementAsDoubleIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__double* traceRet = (dz->getElementAsDouble(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetElementAsDoubleIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__double), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getElementAsDouble(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__decimal * axiscGetElementAsDecimalIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetElementAsDecimalIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__decimal* traceRet = (dz->getElementAsDecimal(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetElementAsDecimalIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__decimal), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getElementAsDecimal(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__string axiscGetElementAsStringIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetElementAsStringIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__string traceRet = (dz->getElementAsString(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetElementAsStringIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_DATA, sizeof(xsdc__string), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getElementAsString(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__anyURI axiscGetElementAsAnyURIIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetElementAsAnyURIIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__anyURI traceRet = (dz->getElementAsAnyURI(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetElementAsAnyURIIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_DATA, sizeof(xsdc__anyURI), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getElementAsAnyURI(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__QName axiscGetElementAsQNameIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetElementAsQNameIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__QName traceRet = (dz->getElementAsQName(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetElementAsQNameIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_DATA, sizeof(xsdc__QName), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getElementAsQName(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__hexBinary * axiscGetElementAsHexBinaryIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetElementAsHexBinaryIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
	// TODO: not implemented yet
	xsdc__hexBinary * hb = new xsdc__hexBinary();
	memset(hb,0,sizeof(hb));
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__hexBinary* traceRet = (hb);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetElementAsHexBinaryIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__hexBinary), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return hb;
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__base64Binary * axiscGetElementAsBase64BinaryIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetElementAsBase64BinaryIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
	// TODO: not implemented yet
	xsdc__base64Binary * bb = new xsdc__base64Binary();
	memset(bb,0,sizeof(bb));
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__base64Binary* traceRet = (bb);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetElementAsBase64BinaryIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__base64Binary), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return bb;
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__dateTime * axiscGetElementAsDateTimeIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetElementAsDateTimeIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__dateTime* traceRet = (dz->getElementAsDateTime(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetElementAsDateTimeIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__dateTime), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getElementAsDateTime(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__date * axiscGetElementAsDateIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetElementAsDateIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__date* traceRet = (dz->getElementAsDate(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetElementAsDateIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__date), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getElementAsDate(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__time * axiscGetElementAsTimeIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetElementAsTimeIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__time* traceRet = (dz->getElementAsTime(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetElementAsTimeIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__time), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getElementAsTime(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__duration * axiscGetElementAsDurationIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetElementAsDurationIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__duration* traceRet = (dz->getElementAsDuration(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetElementAsDurationIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__duration), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getElementAsDuration(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__int * axiscGetAttributeAsIntIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeAsIntIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__int* traceRet = (dz->getAttributeAsInt(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeAsIntIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__int), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getAttributeAsInt(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__boolean * axiscGetAttributeAsBooleanIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeAsBooleanIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__boolean* traceRet = ((xsdc__boolean *)(dz->getAttributeAsBoolean(pName,pNamespace)));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeAsBooleanIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__boolean), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (xsdc__boolean *)(dz->getAttributeAsBoolean(pName,pNamespace));
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__unsignedInt * axiscGetAttributeAsUnsignedIntIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeAsUnsignedIntIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__unsignedInt* traceRet = (dz->getAttributeAsUnsignedInt(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeAsUnsignedIntIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__unsignedInt), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getAttributeAsUnsignedInt(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__short * axiscGetAttributeAsShortIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeAsShortIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__short* traceRet = (dz->getAttributeAsShort(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeAsShortIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__short), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getAttributeAsShort(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__unsignedShort * axiscGetAttributeAsUnsignedShortIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeAsUnsignedShortIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__unsignedShort* traceRet = (dz->getAttributeAsUnsignedShort(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeAsUnsignedShortIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__unsignedShort), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getAttributeAsUnsignedShort(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__byte * axiscGetAttributeAsByteIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeAsByteIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__byte* traceRet = (dz->getAttributeAsByte(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeAsByteIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__byte), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getAttributeAsByte(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__unsignedByte * axiscGetAttributeAsUnsignedByteIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeAsUnsignedByteIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__unsignedByte* traceRet = (dz->getAttributeAsUnsignedByte(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeAsUnsignedByteIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__unsignedByte), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getAttributeAsUnsignedByte(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__long * axiscGetAttributeAsLongIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeAsLongIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__long* traceRet = (dz->getAttributeAsLong(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeAsLongIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__long), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getAttributeAsLong(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__integer * axiscGetAttributeAsIntegerIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeAsIntegerIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__integer* traceRet = (dz->getAttributeAsInteger(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeAsIntegerIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__integer), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getAttributeAsInteger(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__unsignedLong * axiscGetAttributeAsUnsignedLongIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeAsUnsignedLongIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__unsignedLong* traceRet = (dz->getAttributeAsUnsignedLong(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeAsUnsignedLongIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__unsignedLong), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getAttributeAsUnsignedLong(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__float * axiscGetAttributeAsFloatIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeAsFloatIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__float* traceRet = (dz->getAttributeAsFloat(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeAsFloatIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__float), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getAttributeAsFloat(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__double * axiscGetAttributeAsDoubleIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeAsDoubleIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__double* traceRet = (dz->getAttributeAsDouble(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeAsDoubleIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__double), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getAttributeAsDouble(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__decimal * axiscGetAttributeAsDecimalIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeAsDecimalIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__decimal* traceRet = (dz->getAttributeAsDecimal(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeAsDecimalIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__decimal), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getAttributeAsDecimal(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__string axiscGetAttributeAsStringIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeAsStringIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__string traceRet = (dz->getAttributeAsString(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeAsStringIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_DATA, sizeof(xsdc__string), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getAttributeAsString(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__anyURI axiscGetAttributeAsAnyURIIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeAsAnyURIIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__anyURI traceRet = (dz->getAttributeAsAnyURI(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeAsAnyURIIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_DATA, sizeof(xsdc__anyURI), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getAttributeAsAnyURI(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__QName axiscGetAttributeAsQNameIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeAsQNameIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__QName traceRet = (dz->getAttributeAsQName(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeAsQNameIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_DATA, sizeof(xsdc__QName), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getAttributeAsQName(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__hexBinary * axiscGetAttributeAsHexBinaryIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeAsHexBinaryIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
	// TODO not implemented yet
	xsdc__hexBinary * hb = new xsdc__hexBinary();
	memset(hb,0,sizeof(hb));
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__hexBinary* traceRet = (hb);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeAsHexBinaryIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__hexBinary), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return hb;
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__base64Binary * axiscGetAttributeAsBase64BinaryIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeAsBase64BinaryIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
	// TODO not implemented yet
	xsdc__base64Binary * bb = new xsdc__base64Binary();
	memset(bb,0,sizeof(bb));
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__base64Binary* traceRet = (bb);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeAsBase64BinaryIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__base64Binary), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return bb;
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__dateTime * axiscGetAttributeAsDateTimeIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeAsDateTimeIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__dateTime* traceRet = (dz->getAttributeAsDateTime(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeAsDateTimeIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__dateTime), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getAttributeAsDateTime(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__date * axiscGetAttributeAsDateIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeAsDateIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__date* traceRet = (dz->getAttributeAsDate(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeAsDateIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__date), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getAttributeAsDate(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__time * axiscGetAttributeAsTimeIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeAsTimeIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__time* traceRet = (dz->getAttributeAsTime(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeAsTimeIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__time), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getAttributeAsTime(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO xsdc__duration * axiscGetAttributeAsDurationIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer, const AxiscChar * pName, 
	const AxiscChar * pNamespace) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttributeAsDurationIWrapperSoapDeSerializer", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pName),
					TRACETYPE_POINTER, sizeof(AxiscChar), ((void*)&pNamespace));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			xsdc__duration* traceRet = (dz->getAttributeAsDuration(pName,pNamespace));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttributeAsDurationIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(xsdc__duration), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getAttributeAsDuration(pName,pNamespace);
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO int axiscGetStatusIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetStatusIWrapperSoapDeSerializer", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (dz->getStatus());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetStatusIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getStatus();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AXISC_BINDING_STYLE axiscGetStyle(AXISCHANDLE wrapperSoapDeSerializer) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetStyle", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			AXISC_BINDING_STYLE traceRet = ((AXISC_BINDING_STYLE)(dz->getStyle()));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetStyle", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISC_BINDING_STYLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (AXISC_BINDING_STYLE)(dz->getStyle());
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO void axiscSetStyle(AXISCHANDLE wrapperSoapDeSerializer, AXISC_BINDING_STYLE nStyle) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscSetStyle", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_DATA, sizeof(AXISC_BINDING_STYLE), ((void*)&nStyle));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
	dz->setStyle((AXIS_BINDING_STYLE)nStyle);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscSetStyle", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AXISC_STORAGE_CLASS_INFO int axiscGetVersion(AXISCHANDLE wrapperSoapDeSerializer) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetVersion", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (dz->getVersion());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetVersion", NULL, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getVersion();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO int axiscGetHeaderIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetHeaderIWrapperSoapDeSerializer", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (dz->getHeader());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetHeaderIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return dz->getHeader();
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO AxiscAnyType * axiscGetAnyObjectIWrapperSoapDeSerializer(AXISCHANDLE wrapperSoapDeSerializer) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAnyObjectIWrapperSoapDeSerializer", NULL, 1,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			AxiscAnyType* traceRet = ((AxiscAnyType*)(dz->getAnyObject()));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAnyObjectIWrapperSoapDeSerializer", NULL, 0,
					TRACETYPE_POINTER, sizeof(AxiscAnyType), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (AxiscAnyType*)(dz->getAnyObject());
		#endif
	}

}

AXISC_STORAGE_CLASS_INFO void axiscGetChardataAs(AXISCHANDLE wrapperSoapDeSerializer, void * pValue, 
	AXISC_XSDTYPE type) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetChardataAs", NULL, 3,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_POINTER, 1, ((void*)&pValue),
					TRACETYPE_DATA, sizeof(AXISC_XSDTYPE), ((void*)&type));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
	dz->getChardataAs(pValue,(XSDTYPE)type);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetChardataAs", NULL, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AXISC_STORAGE_CLASS_INFO AXISCHANDLE axiscGetAttachmentSoapAttachment(AXISCHANDLE wrapperSoapDeSerializer, const char * pcAttachmentid) {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry(NULL, "axiscGetAttachmentSoapAttachment", NULL, 2,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&wrapperSoapDeSerializer),
					TRACETYPE_STRING, 0, ((void*)&pcAttachmentid));	  /* AUTOINSERTED TRACE */
	#endif

	IWrapperSoapDeSerializer *dz = (IWrapperSoapDeSerializer*)wrapperSoapDeSerializer;
		{
		#ifdef ENABLE_AXISTRACE
			AXISCHANDLE traceRet = ((AXISCHANDLE)(dz->getAttachment(pcAttachmentid)));
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit(NULL, "axiscGetAttachmentSoapAttachment", NULL, 0,
					TRACETYPE_DATA, sizeof(AXISCHANDLE), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (AXISCHANDLE)(dz->getAttachment(pcAttachmentid));
		#endif
	}

}

}

