#ifdef ENABLE_AXISTRACE
/* TRACE ADDED BY THE TRACE INSTRUMENTOR TOOL */
#include "../common/AxisTrace.h"
#endif
/*
 *   Copyright 2003-2004 The Apache Software Foundation.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

#include "SoapAttachmentReference.hpp"

#include "SoapSerializer.h"

#include "Attribute.h"

AXIS_CPP_NAMESPACE_START

SoapAttachmentReference::SoapAttachmentReference(SoapAttachment *att)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("SoapAttachmentReference", "SoapAttachmentReference", this, 1,
					TRACETYPE_POINTER, sizeof(SoapAttachment), ((void*)&att));	  /* AUTOINSERTED TRACE */
	#endif
	
	m_attachment = att;
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("SoapAttachmentReference", "SoapAttachmentReference", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

SoapAttachmentReference::~SoapAttachmentReference() {
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("SoapAttachmentReference", "~SoapAttachmentReference", this, 0);	  /* AUTOINSERTED TRACE */
	#endif
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("SoapAttachmentReference", "~SoapAttachmentReference", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

void SoapAttachmentReference::serialize(SoapSerializer& pSZ, const char *name)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("SoapAttachmentReference", "serialize", this, 2,
					TRACETYPE_DATA, sizeof(SoapSerializer&), ((void*)&pSZ),
					TRACETYPE_STRING, 0, ((void*)&name));	  /* AUTOINSERTED TRACE */
	#endif

	string data = "<";
	data += name;
	if (NULL==m_attachment->getBody())
		data += " xsi:nil=\"true\"";
	else
	{
		data += " href=\"cid:";
		data += m_attachment->getHeader(AXIS_CONTENT_ID);
		data += "\"";
	}
	pSZ.serialize(data.c_str(), NULL);
	list<Attribute*>::iterator it = m_attributes.begin();
	while (it != m_attributes.end())
	{
		pSZ.serialize("\r\n  ",NULL);
		(*it)->serialize(pSZ);
		it++;
	}
	pSZ.serialize("/>\r\n",NULL);
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("SoapAttachmentReference", "serialize", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

void SoapAttachmentReference::addAttributes(IAttribute **attributes, int nAttributes)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("SoapAttachmentReference", "addAttributes", this, 2,
					TRACETYPE_POINTER, sizeof(IAttribute*), ((void*)&attributes),
					TRACETYPE_INT, 0, ((void*)&nAttributes));	  /* AUTOINSERTED TRACE */
	#endif

	if (0==nAttributes || NULL==attributes) 	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("SoapAttachmentReference", "addAttributes", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}

	for (int i=0; i<nAttributes; i++)
		if (NULL!=attributes[i]) 
			m_attributes.push_back(static_cast<Attribute*>(attributes[i]));
		{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("SoapAttachmentReference", "addAttributes", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}

}

AXIS_CPP_NAMESPACE_END

