#ifdef ENABLE_AXISTRACE
/* TRACE ADDED BY THE TRACE INSTRUMENTOR TOOL */
#include "../common/AxisTrace.h"
#endif
/*
 *   Copyright 2003-2004 The Apache Software Foundation.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 * @author Sanjaya Singharage
 *
 */

#include "WSDDHandler.h"

AXIS_CPP_NAMESPACE_START

WSDDHandler::WSDDHandler()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("WSDDHandler", "WSDDHandler", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    m_nLibId = 0;
    m_nScope = AH_REQUEST; /* default */
    m_Params = NULL;
    m_sDescription = "No description provided";
    m_file = 0;
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("WSDDHandler", "WSDDHandler", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

WSDDHandler::~WSDDHandler()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("WSDDHandler", "~WSDDHandler", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    if (m_Params) delete m_Params;
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("WSDDHandler", "~WSDDHandler", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

void WSDDHandler::setLibName(const AxisChar* sLibName)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("WSDDHandler", "setLibName", this, 1,
					TRACETYPE_STRING, 0, ((void*)&sLibName));	  /* AUTOINSERTED TRACE */
	#endif

    m_sLibName = sLibName;
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("WSDDHandler", "setLibName", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

void WSDDHandler::setLibId(int nLibId)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("WSDDHandler", "setLibId", this, 1,
					TRACETYPE_INT, 0, ((void*)&nLibId));	  /* AUTOINSERTED TRACE */
	#endif

    m_nLibId = nLibId;
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("WSDDHandler", "setLibId", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

void WSDDHandler::setName(const AxisChar* sName)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("WSDDHandler", "setName", this, 1,
					TRACETYPE_STRING, 0, ((void*)&sName));	  /* AUTOINSERTED TRACE */
	#endif

    m_sName = sName;
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("WSDDHandler", "setName", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

int WSDDHandler::getLibId() const
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("WSDDHandler", "getLibId", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    	{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (m_nLibId);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("WSDDHandler", "getLibId", this, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return m_nLibId;
		#endif
	}

}

const AxisChar* WSDDHandler::getLibName() const
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("WSDDHandler", "getLibName", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    	{
		#ifdef ENABLE_AXISTRACE
			const AxisChar* traceRet = (m_sLibName.c_str());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("WSDDHandler", "getLibName", this, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return m_sLibName.c_str();
		#endif
	}

}

int WSDDHandler::getScope() const
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("WSDDHandler", "getScope", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    	{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (m_nScope);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("WSDDHandler", "getScope", this, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return m_nScope;
		#endif
	}

}

void WSDDHandler::setScope(const AxisChar* sScope)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("WSDDHandler", "setScope", this, 1,
					TRACETYPE_STRING, 0, ((void*)&sScope));	  /* AUTOINSERTED TRACE */
	#endif

    if (0 == strcmp(sScope, kw_scope_app))
        m_nScope = AH_APPLICATION;    
    else if (0 == strcmp(sScope,kw_scope_ses))
        m_nScope = AH_SESSION;    
    else
        m_nScope = AH_REQUEST;    
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("WSDDHandler", "setScope", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

const AxisChar* WSDDHandler::getParameter(const AxisChar* sKey) const
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("WSDDHandler", "getParameter", this, 1,
					TRACETYPE_STRING, 0, ((void*)&sKey));	  /* AUTOINSERTED TRACE */
	#endif

    if (m_Params->find(sKey) != m_Params->end())
        	{
		#ifdef ENABLE_AXISTRACE
			const AxisChar* traceRet = ((*m_Params)[sKey].c_str());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("WSDDHandler", "getParameter", this, 1,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return (*m_Params)[sKey].c_str();
		#endif
	}

    	{
		#ifdef ENABLE_AXISTRACE
			const AxisChar* traceRet = (NULL);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("WSDDHandler", "getParameter", this, 2,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return NULL;
		#endif
	}

}

void WSDDHandler::addParameter(const AxisChar* sKey, const AxisChar* sValue)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("WSDDHandler", "addParameter", this, 2,
					TRACETYPE_STRING, 0, ((void*)&sKey),
					TRACETYPE_STRING, 0, ((void*)&sValue));	  /* AUTOINSERTED TRACE */
	#endif

    if (!m_Params) m_Params = new map<AxisString, AxisString>;
    (*m_Params)[sKey] = sValue; 
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("WSDDHandler", "addParameter", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

const map<AxisString, AxisString>* WSDDHandler::getParameterList() const
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("WSDDHandler", "getParameterList", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    	{
		#ifdef ENABLE_AXISTRACE
			const map<AxisString , AxisString>* traceRet = (m_Params);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("WSDDHandler", "getParameterList", this, 0,
					TRACETYPE_POINTER, sizeof(map<AxisString , AxisString>), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return m_Params;
		#endif
	}

}

void WSDDHandler::setDescription(const AxisChar* sDescription)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("WSDDHandler", "setDescription", this, 1,
					TRACETYPE_STRING, 0, ((void*)&sDescription));	  /* AUTOINSERTED TRACE */
	#endif

    m_sDescription = sDescription;
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("WSDDHandler", "setDescription", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

const AxisChar* WSDDHandler::getDescription() const
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("WSDDHandler", "getDescription", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    	{
		#ifdef ENABLE_AXISTRACE
			const AxisChar* traceRet = (m_sDescription.c_str());
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("WSDDHandler", "getDescription", this, 0,
					TRACETYPE_STRING, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return m_sDescription.c_str();
		#endif
	}

}

int WSDDHandler::updateWSDD(FILE* wsddfile, int tabcount)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("WSDDHandler", "updateWSDD", this, 2,
					TRACETYPE_POINTER, sizeof(FILE), ((void*)&wsddfile),
					TRACETYPE_INT, 0, ((void*)&tabcount));	  /* AUTOINSERTED TRACE */
	#endif

    m_file = wsddfile;
    printTabs(tabcount); *this << "<handler name=\"" << m_sName.c_str() << 
        "\" type=\"" << m_sLibName.c_str() << "\">\n";
    if (m_Params)
    {
        map<AxisString, AxisString>::iterator itr;
        for (itr = m_Params->begin(); itr != m_Params->end(); itr++)
        {
            printTabs(tabcount+1); *this << "<parameter name=\"" << 
                (*itr).first.c_str() << "\" value=\"" << (*itr).second.c_str() 
                << "\" />\n";
        }
    }
    printTabs(tabcount); *this << "</handler>\n";
    m_file = 0;
    	{
		#ifdef ENABLE_AXISTRACE
			int traceRet = (AXIS_SUCCESS);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("WSDDHandler", "updateWSDD", this, 0,
					TRACETYPE_INT, 0, ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return AXIS_SUCCESS;
		#endif
	}

}

WSDDHandler& WSDDHandler::operator << (const char* str)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("WSDDHandler", "operator<<", this, 1,
					TRACETYPE_STRING, 0, ((void*)&str));	  /* AUTOINSERTED TRACE */
	#endif

    fputs(str, m_file);
    	{
		#ifdef ENABLE_AXISTRACE
			WSDDHandler& traceRet = (*this);
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("WSDDHandler", "operator<<", this, 0,
					TRACETYPE_DATA, sizeof(WSDDHandler&), ((void*)&traceRet));	  /* AUTOINSERTED TRACE */
			return traceRet;
		#else
			return *this;
		#endif
	}

}

void WSDDHandler::printTabs(int count)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("WSDDHandler", "printTabs", this, 1,
					TRACETYPE_INT, 0, ((void*)&count));	  /* AUTOINSERTED TRACE */
	#endif

    for (int x=0; x<count; x++) *this << "\t";
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("WSDDHandler", "printTabs", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

AXIS_CPP_NAMESPACE_END

