#ifdef ENABLE_AXISTRACE
/* TRACE ADDED BY THE TRACE INSTRUMENTOR TOOL */
#include "../common/AxisTrace.h"
#endif
/*
 *   Copyright 2003-2004 The Apache Software Foundation.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 *
 *
 * @author Roshan Weerasuriya (roshan@jkcs.slt.lk)
 *
 */

#include "QName.h"

QName::QName()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("QName", "QName", this, 0);	  /* AUTOINSERTED TRACE */
	#endif

    uri = 0;
    localname = 0;
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("QName", "QName", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

QName::~QName()
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("QName", "~QName", this, 0);	  /* AUTOINSERTED TRACE */
	#endif


	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("QName", "~QName", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

void QName::splitQNameString(const XML_Ch* qname, XML_Ch sep)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("QName", "splitQNameString", this, 2,
					TRACETYPE_STRING, 0, ((void*)&qname),
					TRACETYPE_DATA, sizeof(XML_Ch), ((void*)&sep));	  /* AUTOINSERTED TRACE */
	#endif

    XML_Ch *p = const_cast<XML_Ch*>(qname);
    while (*p)
    {
        if (*p == sep)
        {
            *p = '\0'; /* put null to separate local name from namespace */
            localname = ++p; /* now p points to localpart */
            uri = qname; /* qname points to uri */
            	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("QName", "splitQNameString", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
 
        }
        p++;
    }
    /* if there is no separator that means there is no uri */
    localname = qname;
    uri = 0; /* no uri */
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("QName", "splitQNameString", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

void QName::mergeQNameString(XML_Ch sep)
{
	#ifdef ENABLE_AXISTRACE
		if (axiscpp::AxisTrace::isTraceOn())
			axiscpp::AxisTrace::traceEntry("QName", "mergeQNameString", this, 1,
					TRACETYPE_DATA, sizeof(XML_Ch), ((void*)&sep));	  /* AUTOINSERTED TRACE */
	#endif

    if (uri)
    {
        XML_Ch* p = const_cast<XML_Ch*>(localname);
        *(--p) = sep;
    }
	{
		#ifdef ENABLE_AXISTRACE
			if (axiscpp::AxisTrace::isTraceOn())
				axiscpp::AxisTrace::traceExit("QName", "mergeQNameString", this, 0);	  /* AUTOINSERTED TRACE */
		#endif
		return;
	}
}

